#include<bits/stdc++.h>
using namespace std;

const int nmax=5e4+42,MX=1e7+42;

int n,a,p[nmax];

int m,b,q[nmax];

bool meet(int i,int j)
{
    int x1=a-p[i];
    int x2=a+p[i];

    int x3=b-q[j];
    int x4=b+q[j];

    return x1<x3&&x3<x2&&x2<x4;
}

bool meet_special(int i,int j)
{
    int x1=a-p[i];
    int x2=a+p[i];

    int x3=b-q[j];
    int x4=b+q[j];

    return x1<=x3&&x3<=x2&&x2<=x4;
}

int first_valid(int i)
{
    int x1=a-p[i];
    int x2=a+p[i];

    int pos=upper_bound(q+1,q+m+1,abs(b-x2))-q;
    return pos;
}

int last_valid(int i)
{
    int x1=a-p[i];
    int x2=a+p[i];

    int pos=lower_bound(q+1,q+m+1,abs(b-x1))-q;

    return pos-1;
}

int first_valid_special(int i)
{
    int x1=a-p[i];
    int x2=a+p[i];

    int pos=lower_bound(q+1,q+m+1,abs(b-x2))-q;
    return pos;
}

int last_valid_special(int i)
{
    int x1=a-p[i];
    int x2=a+p[i];

    int pos=upper_bound(q+1,q+m+1,abs(b-x1))-q;

    return pos-1;
}

int main()
{
    scanf("%i",&n);
    scanf("%i",&a);
    for(int i=1;i<=n;i++)
    {
        scanf("%i",&p[i]);
        p[i]=p[i]/2;
    }
    sort(p+1,p+n+1);

    scanf("%i",&m);
    scanf("%i",&b);
    for(int i=1;i<=m;i++)
    {
        scanf("%i",&q[i]);
        q[i]=q[i]/2;
    }

    sort(q+1,q+m+1);

    b=b-a;
    a=0;

    long long outp=n+m;

    for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
        {
            if(i>=2&&j>=2)break;
            if(meet(i,j))outp++;
        }

    for(int i=2;i<=n;i++)
    {
        int beg=first_valid(i),en=last_valid(i);

        beg=max(beg,2);

        en=min(en,m);

        if(beg>en)continue;

        outp+=en-beg+1;

        pair<int,int> valid[4];
        valid[0]={beg,en};

        valid[1]={first_valid_special(i-1),last_valid_special(i-1)};

        valid[2]={first_valid_special(i)+1,last_valid_special(i)+1};

        valid[3]={valid[1].first+1,valid[1].second+1};

        int total_left=0,total_right=n+1;

        for(int t=0;t<4;t++)
        {
            total_left=max(total_left,valid[t].first);
            total_right=min(total_right,valid[t].second);
        }

        if(total_left<=total_right)outp+=total_right-total_left+1;
        /*
        cout<<i<<" -> "<<total_left<<" "<<total_right<<endl;

        cout<<"VALID: "<<endl;
        for(int t=0;t<4;t++)
        {
            cout<<valid[t].first<<" "<<valid[t].second<<endl;
        }
        */

        /*
        for(int j=beg;j<=en;j++)
        {
            //if(meet(i,j)==0)continue;

            if(meet_special(i,j-1)&&meet_special(i-1,j-1))
            {
                outp++;
                cout<<" special "<<i<<" "<<j<<endl;
            }
            //cout<<"meet "<<i<<" "<<j<<endl;
        }
        */
    }
    printf("%lld\n",outp);
    return 0;
}
/*
1
0
12
1
2
14

2
7
2 8
3
8
2 12 6


2
7
2 8
3
1000
2 12 8

2
-2
2 4
2
0
2 4

3
-2
2 4 6
3
0
2 4 6
*/
