#include "multisort.h"

#include<bits/stdc++.h>
using namespace std;

const int nmax=2e4+42;

vector<int> adj[nmax];

int in[nmax];

set< int/*id*/ > active;
/*
void compare(vector<int> &cur)
{
    for(auto k:cur)cout<<k<<" ";cout<<endl;

    for(int i=0;i<cur.size();i++)
    {
        int t;
        cin>>t;

        cur[i]=t;
    }
}
*/
void push_edge(int u,int v)
{
    adj[u].push_back(v);
    in[v]++;

    if(active.count(v))active.erase(v);
}

void pop(int node)
{
    active.erase(node);

    for(auto k:adj[node])
    {
        in[k]--;
        if(in[k]==0)active.insert(k);
    }
}
std::vector<int> multisort(int n, int k)
{
    for(int i=0;i<n;i++)
        active.insert(i);

    vector<int> ret={};

    while(ret.size()<n)
    {
        vector<int> cur={};

        set<int>::iterator it=active.begin();

        for(int t=0;t<k&&t<active.size();t++)
        {
            cur.push_back(*it);
            it++;
        }

        if(cur.size()==1)
        {
            ret.push_back(cur[0]);

            //cout<<"pop "<<cur[0]<<endl;

            pop(cur[0]);
            continue;
        }

        compare(cur);

        for(int t=1;t<cur.size();t++)
        {
            push_edge(cur[t-1],cur[t]);
        }
    }
    return ret;
}
/*
int main()
{
    for(auto w:multisort(4,3))cout<<w<<" ";cout<<endl;

    return 0;
}
*/