#include "multisort.h"

#include<bits/stdc++.h>
using namespace std;

const int nmax=2e4+42;

vector<int> adj[nmax];

int in[nmax];

int priority[nmax];

set< pair<int/*priority*/,int/*id*/ > > active;
/*
void compare(vector<int> &cur)
{
    for(auto k:cur)cout<<k<<" ";cout<<endl;

    for(int i=0;i<cur.size();i++)
    {
        int t;
        cin>>t;

        cur[i]=t;
    }
}
*/
void push_edge(int u,int v)
{
    adj[u].push_back(v);
    in[v]++;

    active.erase({priority[u],u});

    priority[u]=max(priority[u],priority[v]+1);

    if(active.count({priority[v],v}))active.erase({priority[v],v});

    active.insert({priority[u],u});
}

void pop(int node)
{
    active.erase({priority[node],node});

    for(auto k:adj[node])
    {
        in[k]--;
        if(in[k]==0)active.insert({priority[k],k});
    }
}
std::vector<int> multisort(int n, int k)
{
    for(int i=0;i<n;i++)
        active.insert({0,i});

    vector<int> ret={};

    while(ret.size()<n)
    {
        /*
        for(int t=0;t<n;t++)cout<<priority[t]<<" ";cout<<endl;

        for(auto k:active)
        {
            cout<<k.first<<" "<<k.second<<endl;
        }

        cout<<"---"<<endl;
        */


        vector<int> cur={};

        set< pair<int/*priority*/,int/*id*/> >::iterator it=active.begin();

        for(int t=0;t<k&&t<active.size();t++)
        {
            cur.push_back((*it).second);
            it++;
        }

        if(cur.size()==1)
        {
            ret.push_back(cur[0]);

            //cout<<"pop "<<cur[0]<<endl;

            pop(cur[0]);
            continue;
        }

        int STOP=k;

        if(n-ret.size()<STOP)STOP=n-ret.size();

        if(cur.size()<STOP)
        {
            set<int> in={};
            for(auto w:cur)in.insert(w);

            for(int t=0;in.size()<STOP;t++)
            {
                for(auto p:adj[cur[t]])
                {
                    //cout<<t<<" "<<p<<endl;
                    if(in.count(p)==0)
                    {
                        in.insert(p);
                        cur.push_back(p);

                        if(cur.size()==STOP)break;
                    }
                }
            }
        }
        compare(cur);

        for(int t=cur.size()-1;t>0;t--)
        {
            push_edge(cur[t-1],cur[t]);
        }
    }
    return ret;
}
/*
int main()
{
    for(auto w:multisort(9,3))cout<<w<<" ";cout<<endl;

    return 0;
}
*/
