#include<iostream>
#include<algorithm>
using namespace std;
const int maxn = 1e5;
int n, m;
int xa, xb;
int d;
int a[maxn], b[maxn];

bool intersect(int i, int j, bool strict)
{
    //cout << i << " " << j << ": " << ((a[i] + b[i]) / 2 > d) << (a[i] / 2 < d + b[i] / 2) << (b[i] / 2 < d + a[i] / 2) << endl;
    if(strict)
        return (a[i] + b[j]) / 2 > d && a[i] / 2 < d + b[j] / 2 && b[j] / 2 < d + a[i] / 2;
    else
        return (a[i] + b[j]) / 2 >= d && a[i] / 2 <= d + b[j] / 2 && b[j] / 2 <= d + a[i] / 2;
}

int inter_type(int i, int j)
{
    if(intersect(i, j, true))
    {
        if(i > 0 && j > 0)
        {
            if(intersect(i, j - 1, false) && intersect(i - 1, j, false) && intersect(i - 1, j - 1, false))
            {
                return 2; /// inner intersection
            }
        }

        if(i > 0 && a[i - 1] / 2 + d < b[j] / 2)
        {
            return 3; /// eaten intersection
        }

        return 1; /// outer intersection
    }
    if(a[i] / 2 + d <= b[j] / 2)
        return 4; /// eaten
    return 0; ///dont touch
}

int find_state(int i, int st)
{
    int bla = 0;
    for(;bla < m && inter_type(i, bla) < st; bla ++){}
    return bla;

    if(inter_type(i, m - 1) < st)  return m;
    if(inter_type(i, 0) > st)  return 0;
    int l = -1, r = m;
    int _m;
    while(l + 1 < r)
    {
        _m = (l + r) / 2;
        int cst = inter_type(i, _m);
        if(cst >= st)   r = _m;
        else    l = _m;
    }
    return r;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    cin >> xa;
    for(int i = 0; i < n; i ++)
    {
        cin >> a[i];
    }
    sort(a, a + n);
    cin >> m;
    cin >> xb;
    for(int i = 0; i < m; i ++)
    {
        cin >> b[i];
    }
    sort(b, b + m);

    d = abs(xb - xa);

    int ans = n + m;

    for(int i = 0; i < n; i ++)
    {
        int ti[5] = {};
        for(int j = 0; j < 5; j ++) ti[j] = find_state(i, j);
        for(int j = 0; j < 4; j ++)
        {
            int nw = min(j, 4 - j);
            ans += nw * (ti[j + 1] - ti[j]);
        }
        //cout << i << ": ";
        //for(int j = 0; j < 5; j ++) cout << ti[j] << " ";
        //cout << endl;
    }
    cout << ans;
}
/**
2
7
2 8
3
10
2 12 6
*/
/**
2
0
10 12
2
10
10 12

*/
