#include"multisort.h"
#include<algorithm>
#include<map>


std::map<std::pair<int,int>, bool> checked;

bool cmp_forsort(int a, int b)
{
    if(checked.count({a,b}) > 0)    return checked[{a,b}];
    if(checked.count({b,a}) > 0)    return !checked[{b,a}];

    std::vector<int> vec;
    vec.push_back(a);
    vec.push_back(b);
    compare(vec);
    checked[{a,b}] = (vec[0] == a);
    return checked[{a,b}];
}

std::vector<int> multisort(int n, int k)
{
    std::vector<int> ans(n);
    for(int i = 0; i < n; i ++) ans[i] = i;
    std::sort(ans.begin(), ans.end(), cmp_forsort);
    return ans;
}
