#include"multisort.h"
#include<algorithm>
#include<map>
#include<unordered_map>
#include<random>
#include<iostream>


std::map<std::pair<int,int>, bool> checked;

bool cmp_forsort(int a, int b)
{
    if(checked.count({a,b}) > 0)    return checked[{a,b}];
    if(checked.count({b,a}) > 0)    return !checked[{b,a}];

    std::vector<int> vec;
    vec.push_back(a);
    vec.push_back(b);
    compare(vec);
    checked[{a,b}] = (vec[0] == a);
    return checked[{a,b}];
}


std::vector<int> multisort(int n, int k)
{
    srand(123);



    int num_comp = 0;

    if(k >= 20 && k <= 100)  num_comp = 100;

    std::vector<int> for_perm(n);
    for(int i = 0; i < n; i ++) for_perm[i] = i;

    std::vector<int> vec(k);
    for(int i = 0; i < num_comp; i ++)
    {
        std::random_shuffle(for_perm.begin(), for_perm.end());
        for(int j = 0; j < k; j ++) vec[j] = for_perm[j];
        compare(vec);
        for(int j = 0; j < k; j ++)
        {
            for(int l = j + 1; l < k; l ++)
            {
                checked[{vec[j], vec[l]}] = true;
            }
        }
    }

    std::vector<int> ans(n);
    for(int i = 0; i < n; i ++) ans[i] = i;
    std::sort(ans.begin(), ans.end(), cmp_forsort);
    return ans;
}
