#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 5e4 + 3;

int n, x, a[maxn];
int m, y, b[maxn];
void read()
{
    cin >> n >> x;
    for (int i = 1; i <= n; i++)
        cin >> a[i];

    cin >> m >> y;
    for (int i = 1; i <= m; i++)
    cin >> b[i];
}

bool is = false;
map <pair <int, int>, bool> banned[4];
map <pair <int, int>, bool> used;

int cnt = 0;
void dfs(int x, int y)
{
    used[{x, y}] = true;
    if (!used.count({x-1, y}) && !banned[0].count({x, y}))
        dfs(x-1, y);

    if (!used.count({x+1, y}) && !banned[1].count({x, y}))
        dfs(x+1, y);

    if (!used.count({x, y-1}) && !banned[2].count({x, y}))
        dfs(x, y-1);

    if (!used.count({x, y+1}) && !banned[3].count({x, y}))
        dfs(x, y+1);
}

void solve()
{
    bool is = true;
    for (int i = 1; i <= n; i++)
        if (a[i] > 1000)
        {
            is = false;
            break;
        }

    for (int i = 1; i <= m; i++)
        if (b[i] > 1000)
    {
        is = false;
        break;
    }

    if (!is)
    {
        int ans = n + m;
        for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
        {
            pair <int, int> first = {x - a[i] / 2, x + a[i] / 2};
            pair <int, int> second = {y - b[j] / 2, y + b[j] / 2};

            if (first.first > second.first)
                swap(first, second);

            if (first.second >= second.first && second.second > first.second)
                ans++;
        }

        cout << ans << endl;
    }

    else
    {
        sort (a + 1, a + n + 1);
        sort (b + 1, b + m + 1);
        for (int i = 1; i <= n; i++)
        {
            for (int j = x - a[i] / 2; j <= x + a[i] / 2 - 1; j++)
            {
                banned[2][{j, a[i] / 2}] = true;
                banned[3][{j, -a[i] / 2 - 1}] = true;
                banned[3][{j, a[i] / 2 - 1}] = true;
                banned[2][{j, -a[i] / 2}] = true;
            }

            for (int j = -a[i] / 2; j <= a[i] / 2 - 1; j++)
            {
                banned[1][{x-a[i]/2-1, j}] = true;
                banned[0][{x+a[i]/2, j}] = true;
                banned[0][{x-a[i]/2, j}] = true;
                banned[1][{x+a[i]/2-1, j}] = true;
            }
        }

        for (int i = 1; i <= m; i++)
        {
            for (int j = y - b[i] / 2; j <= y + b[i] / 2 - 1; j++)
            {
                banned[2][{j, b[i] / 2}] = true;
                banned[3][{j, -b[i] / 2 - 1}] = true;
                banned[3][{j, b[i] / 2 - 1}] = true;
                banned[2][{j, -b[i] / 2}] = true;
            }

            for (int j = -b[i] / 2; j <= b[i] / 2 - 1; j++)
            {
                banned[1][{y-b[i]/2-1, j}] = true;
                banned[0][{y+b[i]/2, j}] = true;
                banned[0][{y-b[i]/2, j}] = true;
                banned[1][{y+b[i]/2-1, j}] = true;
            }
        }

        int ans = 0;
        for (int i = x - a[n] / 2; i <= x + a[n] / 2 - 1; i++)
            for (int j = -a[n] / 2; j <= a[n] / 2 - 1; j++)
        if (!used.count({i, j}))
        {
            ans++;
            dfs(i, j);
        }

        for (int i = y - b[m] / 2; i <= y + b[m] / 2 - 1; i++)
            for (int j = -b[m] / 2; j <= b[m] / 2 -1; j++)
        if (!used.count({i, j}))
        {
            ans++;
            dfs(i, j);
        }

        cout << ans << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
