#include <bits/stdc++.h>
#include "multisort.h"

using namespace std;


void compare(vector <int> &elems);

int kk;
vector <int> merge_sort(vector <int> v)
{
    if ((int)v.size() <= kk)
        {
            if ((int)v.size() == 1)
                return v;

            vector <int> v1;
            for (auto i: v)
                v1.push_back(i);

            int diff = kk - (int)v1.size();
            for (int i = 1; i <= diff; i++)
                v1.push_back(v[0]);

                compare(v1);
                v.clear();

            for (int i = 0; i < kk; i++)
                if (i == 0 || v1[i] != v1[i-1])
                    v.push_back(v1[i]);

            return v;
        }

    vector <int> v1, v2;
    int mid = (int)v.size() / 2;
    for (int i = 0; i < mid; i++)
        v1.push_back(v[i]);

    for (int i = mid; i < (int)v.size(); i++)
        v2.push_back(v[i]);

    v1 = merge_sort(v1);
    v2 = merge_sort(v2);

    vector <int> ans;
    int pos1 = 0, pos2 = 0;
    while (pos1 < (int)v1.size() && pos2 < (int)v2.size())
    {
        vector <int> curr;
        for (int i = pos1; i <= min((int)v1.size()-1, pos1 + kk / 2 - 1); i++)
            curr.push_back(v1[i]);

        for (int i = pos2; i <= min((int)v2.size()-1, pos2 + kk / 2 - 1); i++)
            curr.push_back(v2[i]);

        int diff = kk - (int)curr.size();
        for (int i = 1; i <= diff; i++)
            curr.push_back(v1[pos1]);

        compare(curr);
        int cnt = 0;
        for (int i = 0; i < kk && cnt < kk / 2; i++)
        {
            if (i != 0 && curr[i] == curr[i-1])
                continue;

            cnt++;
            if (pos1 < (int)v1.size() && v1[pos1] == curr[i])
            {
                ans.push_back(curr[i]);
                pos1++;
            }

            if (pos2 < (int)v2.size() && v2[pos2] == curr[i])
            {
                ans.push_back(curr[i]);
                pos2++;
            }
        }
    }

    while (pos1 < (int)v1.size())
    {
        ans.push_back(v1[pos1]);
        pos1++;
    }

    while (pos2 < (int)v2.size())
    {
        ans.push_back(v2[pos2]);
        pos2++;
    }

    return ans;
}

vector <int> multisort(int n, int k)
{
    kk = k;
    vector <int> v;
    for (int i = 0; i < n; i++)
    v.push_back(i);

    return merge_sort(v);
}
