#include <bits/stdc++.h>
#include "rain.h"

using namespace std;

const int maxn = 3e5 + 3;
const double eps = 0.00001;

vector <pair <long long, int> > adj[maxn];
int nn;
void init(int n, int m, int a[], int b[], long long c[])
{
    nn = n;
    for (int i = 0; i < m; i++)
    {
        adj[a[i]].push_back({c[i], b[i]});
        adj[b[i]].push_back({c[i], a[i]});
    }

    for (int i = 1; i <= n; i++)
        sort (adj[i].begin(), adj[i].end());
}

double ans[maxn];
void pass(int ver)
{
    for (auto i: adj[ver])
    {
        if (i.first >= ans[ver])
            break;

        double t = min(ans[ver] - i.first, (ans[ver] - ans[i.second]) / 2.0);
        if (t < eps)
            continue;

        ans[ver] -= t;
        ans[i.second] += t;
        pass(ver);
        pass(i.second);
        pass(ver);
    }

}

double query(long long w, int k)
{
    for (int i = 1; i <= nn; i++)
        ans[i] = 0;

    ans[1] = w;
    pass(1);

    return ans[k];
}


/*
int main()
{
    int n, m, a[1003], b[1003];
    long long c[1003];
    cin >> n >> m;
    for (int i = 0; i < m; i++)
        cin >> a[i] >> b[i] >> c[i];

    init(n, m, a, b, c);

    int q;
    cin >> q;
    while (q--)
    {
        long long w;
        int k;
        cin >> w >> k;

        cout << query(w, k) << endl;
    }
}
*/
/*
3 2
1 2 1
1 3 5
3
2 1
3 1
14 3
*/
