#include<algorithm>
#include<iostream>
#include<random>
#include<vector>
#include"multisort.h"

using namespace std;

//mt19937 generator;

vector<int>buckets[20002];

int m_cnt;
std::vector<int> m_sort(int lind,int rind){
    if(lind==rind){
        return buckets[lind];
    }
    bool inl[20002];
    vector<int>l,r;
    l=m_sort(lind,(lind+rind)/2);
    r=m_sort((lind+rind)/2+1,rind);
    for(int i=0;i<l.size();i++){
        inl[l[i]]=1;
    }
    for(int i=0;i<r.size();i++){
        inl[r[i]]=0;
    }
    /*cout<<"Trying to sort: "<<endl<<"   ";
    for(int i=0;i<l.size();i++){
        cout<<l[i]<<" ";
    }
    cout<<endl<<"   ";
    for(int i=0;i<r.size();i++){
        cout<<r[i]<<" ";
    }
    cout<<endl;*/
    int li=0,ri=0;
    vector<int>ans;
    while(li<l.size() || ri<r.size()){
        vector<int>query;
        int lc=0,rc=0;
        for(int i=0;i<m_cnt;i++){
            if((i%2==0 || ri+rc==r.size()) && li+lc<l.size()){
                query.push_back(l[li+lc]);
                lc++;
            }else if(ri+rc<r.size()){
                query.push_back(r[ri+rc]);
                rc++;
            }
        }
        /*cout<<"Checking for: "<<endl<<"   ";
        for(int i=0;i<query.size();i++){
            cout<<query[i]<<" ";
        }
        cout<<endl;*/
        if(rc==0){
            for(int i=li;i<l.size();i++){
                ans.push_back(l[i]);
            }
            //curr.push_back(query[0]);
            break;
        }
        if(lc==0){
            for(int i=ri;i<r.size();i++){
                ans.push_back(r[i]);
            }
            //curr.push_back(query[0]);
            break;
        }
        compare(query);
        /*cout<<"Result: "<<endl<<"   ";
        for(int i=0;i<query.size();i++){
            cout<<query[i]<<" ";
        }
        cout<<endl;*/
        bool cmp=inl[query[query.size()-1]];
        int ending=1;
        for(int i=query.size()-2;i>=0;i--){
            if(inl[query[i]]==cmp){
                ending++;
            }else{
                break;
            }
        }
        //cout<<"Ending: "<<ending<<endl;
        for(int i=0;i<query.size()-ending;i++){
            ans.push_back(query[i]);
            if(li<l.size() && query[i]==l[li]){
                li++;
            }else{
                ri++;
            }
        }
    }
    /*cout<<endl<<"Final result: "<<endl<<"   ";
    for(int i=0;i<curr.size();i++){
        cout<<curr[i]<<" ";
    }
    cout<<endl;*/
    return ans;
}
std::vector<int> multisort(int n, int k){
    m_cnt=k;
    vector<int>ans;
    for(int i=0;i<n;i++){
        //ans.push_back(i);
        buckets[i/m_cnt].push_back(i);
    }
    int bcnt=(n-1)/k;
    for(int i=0;i<=bcnt;i++){
        compare(buckets[i]);
    }
    //shuffle(ans.begin(), ans.end(), generator);
    return m_sort(0,bcnt);
    //return ans;
}
