#include <bits/stdc++.h>
#define int long long
using namespace std;
int n, m, ax, bx, a [50004], b [50004], ans;
vector <int> pts;
int tree [800005];
void upd (int l, int r, int pos, int x){
    if (l == r){
        tree [pos] ++;
        return;
    }
    int mid = l +  r >> 1;
    if (x <= mid) upd (l, mid, pos << 1, x);
    else upd (mid + 1, r, pos << 1 | 1, x);
    tree [pos] ++;
}
int query (int l, int r, int pos, int ql, int qr){
    if (l >= ql && r <= qr) return tree [pos];
    if (l > qr || r < ql) return 0;
    int mid = l +  r >> 1;
    return query (l, mid, pos << 1, ql, qr) + query (mid + 1, r, pos << 1 | 1, ql, qr);
}
signed main (){

	ios::sync_with_stdio (false);
	cin.tie (0);

	cin >> n >> ax;
	for (int i = 0; i < n; i ++){
        cin >> a [i];
        a [i] /= 2;
        pts.push_back (ax - a [i]);
        pts.push_back (ax + a [i]);
	}
	sort (a, a + n);
	cin >> m >> bx;
	for (int i = 0; i < m; i ++){
        cin >> b [i];
        b [i] /= 2;
        pts.push_back (bx - b [i]);
        pts.push_back (bx + b [i]);
	}
	sort (b, b + m);
	sort (pts.begin (), pts.end ());
	vector <int> pts1;
	pts1.push_back (pts [0]);
	for (int i = 1; i < pts.size (); i ++) if (pts [i] != pts [i - 1]) pts1.push_back (pts [i]);
	pts = pts1;
	int sz = pts.size () - 1;
	int ra = n - 1, rb = m - 1;
	while (ra >= 0 || rb >= 0){
        if (rb == -1 || a [ra] > b [rb]){
            int pos1 = lower_bound (pts.begin (), pts.end (), ax - a [ra]) - pts.begin ();
            int pos2 = lower_bound (pts.begin (), pts.end (), ax + a [ra]) - pts.begin ();
            upd (0, sz, 1, pos2);
            ans += 1 + query (0, sz, 1, pos1 + 1, pos2 - 1);
            if (ra > 0){
                pos1 = lower_bound (pts.begin (), pts.end (), ax - a [ra - 1]) - pts.begin ();
                if (rb >= 0 && bx + b [rb] >= ax + a [ra] && bx - b [rb] <= ax + a [ra - 1]){
                    ans += query (0, sz, 1, pos1, pos2 - 1);
                }
                else{
                    pos2 = lower_bound (pts.begin (), pts.end (), ax + a [ra - 1]) - pts.begin ();
                    ans += max (0ll, query (0, sz, 1, pos1, pos2) - 1);
                }
            }
            ra --;
        }
        else{
            int pos1 = lower_bound (pts.begin (), pts.end (), bx - b [rb]) - pts.begin ();
            int pos2 = lower_bound (pts.begin (), pts.end (), bx + b [rb]) - pts.begin ();
            upd (0, sz, 1, pos1);
            ans += 1 + query (0, sz, 1, pos1 + 1, pos2 - 1);
            if (rb > 0){
                pos2 = lower_bound (pts.begin (), pts.end (), bx + b [rb - 1]) - pts.begin ();
                if (ra >= 0 && ax - a [ra] <= bx - b [rb] && ax + a [ra] >= bx - b [rb - 1]){
                    ans += query (0, sz, 1, pos1 + 1, pos2);
                }
                else{
                    pos1 = lower_bound (pts.begin (), pts.end (), bx - b [rb - 1]) - pts.begin ();
                    ans += max (0ll, query (0, sz, 1, pos1, pos2) - 1);
                }
            }
            rb --;
        }
	}
	cout << ans << '\n';

}
