#include <bits/stdc++.h>
#include "multisort.h"
using namespace std;
int n, k;
vector <int> V1, V2;
vector <int> solve (int l1, int r1, int l2, int r2){
    if (l1 > r1) return {};
    int mid = l1 + r1 >> 1;
    int l = l2, r = r2;
    while (l < r){
        int m = l + r + 1 >> 1;
        vector <int> ask;
        for (int i = 1; i < k && m + i - 1 <= r; i ++) ask.push_back (V2 [m + i - 1]);
        ask.push_back (V1 [mid]);
        compare (ask);
        if (V1 [mid] == ask [0]) r = m - 1;
        else if (V1 [mid] == ask.back ()) l = m + ask.size () - 2;
        else{
            int sz = ask.size ();
            for (int i = 0; i < sz; i ++){
                if (V1 [mid] == ask [i]){
                    l = r = m + i - 1;
                    break;
                }
            }
        }
    }
    if (r == -1) l = -1;
    if (l1 == r1) return {l};
    vector <int> L = solve (l1, mid - 1, l2, l), R = solve (mid + 1, r, r2);
    vector <int> ans = L;
    ans.push_back (l);
    for (int i : R) ans.push_back (i);
    return ans;
}
void mergesort (vector <int> &v){
    int sz = v.size (), halfsz = sz >> 1;
    if (sz <= k){
        compare (v);
        return;
    }
    vector <int> v1, v2;
    for (int i = 0; i < halfsz; i ++) v1.push_back (v [i]);
    for (int i = halfsz; i < sz; i ++) v2.push_back (v [i]);
    int mid = v [halfsz];
    v.clear ();
    mergesort (v1);
    mergesort (v2);
    V1 = v1;
    V2 = v2;
    vector <int> pos = solve (0, v1.size () - 1, 0, v2.size () - 1);
    int l = 0;
    for (int i = 0; i < v1.size (); i ++){
        while (pos [i] >= l) v.push_back (v2 [l ++]);
        v.push_back (v1 [i]);
    }
    return v;
    /*
    int l1 = 0, l2 = 0, sz1 = halfsz, sz2 = sz - halfsz;
    while (l1 < sz1 && l2 < sz2){
        vector <int> v3;
        for (int i = 0; i < min (k / 2, sz1 - l1); i ++) v3.push_back (v1 [l1 + i]);
        l1 = min (l1 + k / 2, sz1);
        for (int i = 0; i < min (k - k / 2, sz2 - l2); i ++) v3.push_back (v2 [l2 + i]);
        l2 = min (l2 + k - k / 2, sz2);
        compare (v3);
        if (v3.back () < mid){
            while (v3.back () < mid) l1 --, v3.pop_back ();
        }
        else{
            while (v3.back () >= mid) l2 --, v3.pop_back ();
        }
        for (int i : v3) v.push_back (i);
    }
    while (l1 < sz1){
        v.push_back (v1 [l1 ++]);
    }
    while (l2 < sz2){
        v.push_back (v2 [l2 ++]);
    }*/
}
vector <int> multisort (int N, int K){
    n = N;
    k = K;
    vector <int> v (n);
    for (int i = 0; i < n; i ++) v [i] = i;
    mergesort (v);
    return v;
}
