#include<iostream>
#include<algorithm>
using namespace std;
const int maxn = 1e5;
int n, m;
int xa, xb;
int d;
int a[maxn], b[maxn];

bool intersect(int i, int j, bool strict)
{
    //cout << i << " " << j << ": " << ((a[i] + b[i]) / 2 > d) << (a[i] / 2 < d + b[i] / 2) << (b[i] / 2 < d + a[i] / 2) << endl;
    if(strict)
        return (a[i] + b[j]) / 2 > d && a[i] / 2 < d + b[j] / 2 && b[j] / 2 < d + a[i] / 2;
    else
        return (a[i] + b[j]) / 2 >= d && a[i] / 2 <= d + b[j] / 2 && b[j] / 2 <= d + a[i] / 2;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    cin >> xa;
    for(int i = 0; i < n; i ++)
    {
        cin >> a[i];
    }
    sort(a, a + n);
    cin >> m;
    cin >> xb;
    for(int i = 0; i < m; i ++)
    {
        cin >> b[i];
    }
    sort(b, b + m);

    d = abs(xb - xa);

    int ans = n + m;

    for(int i = 0; i < n; i ++)
    {
        for(int j = 0; j < m; j ++)
        {
            if(intersect(i, j, true))
            {
                //cout << i << " " << j << endl;
                ans ++;
                if(i > 0 && j > 0)
                {
                    if(intersect(i, j - 1, false) && intersect(i - 1, j, false) && intersect(i - 1, j - 1, false))
                    {
                        ans ++;
                    }
                }
            }
        }
    }
    cout << ans;
}
/**
2
7
2 8
3
10
2 12 6
*/
/**
2
0
10 12
2
10
10 12

*/
