#include <iostream>
#include <vector>
#include "multisort.h"

using namespace std;

void compare(vector<int>& elems);

vector<int> v;
int n, k;
mt19937 mt(7);

int rnd(int mod){
    return mt() % mod;
}

vector<int> multisort(int _n, int _k){
    n = _n;
    k = _k;

    int log_n = 0, t = 1;
    while(t < n){
        t *= k;
        log_n++;
    }

    int cnt = n * log_n * 3 / k;
    vector<int> permutation;
    for(int i = 0; i < n; ++i)
        permutation.push_back(i);

    for(int i = 0; i < cnt; ++i){
        random_shuffle(permutation.begin(), permutation.end(), rnd);
        vector<int> t;
        for(int i = 0; i < k; ++i)
            t.push_back(v[permutation[i]]);
        compare(t);
        for(int i = 0; i < k; ++i)
            v[permutation[i]] = t[i];
    }

    return v;
}

