#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include "multisort.h"

#pragma GCC optimization("O3")

#define pb push_back
#define fr first
#define sc second
#define ll long long
#define ld long double
#define bit(x) x&(-x)
#define bin(x, a) bitset<a>(x)
#define all(x) x.begin(), x.end()
#define de(x) cout << #x << " = " << x << endl;
#define matrix vector<vector<int>>
#define row vector<int>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
/// find_by_order(x) -> x-th element in the set
/// order_of_key(x)  -> how many elements are smaller than x

row merge(row a, row b){
    int p1 = 0, p2 = 0;
    row c(a.size() + b.size());
    for(int i = 0; i < c.size(); i ++){
        if(p1 == a.size()){
            c[i] = b[p2];
            ++ p2;
        }
        else if(p2 == b.size()){
            c[i] = a[p1];
            ++ p1;
        }
        else{
            row t({a[p1], b[p2]});
            compare(t);
            if(t[0] == a[p1]){
                c[i] = b[p2];
                ++ p2;
            }
            else{
                c[i] = a[p1];
                ++ p1;
            }
        }
    }
    return c;
}

row multisort(int n, int k){
    row A;
    for(int i = 0; i < A.size(); i ++) A[i] = i;
    for(int l = 0, r = k - 1; r < n; l = r + 1, r = min(l + k - 1, n - 1)){
        row give(r - l + 1);
        for(int i = 0; i < r - l + 1; i ++){
            give[i] = A[i + l];
        }
        compare(give);
        for(int i = 0; i < r - l + 1; i ++){
            A[i + l] = give[i];
        }
    }
    matrix B;
    for(int i = 0; i < A.size(); i ++){
        B[i % k].pb(A[i]);
    }
    while(B.size() != 1){
        int p = 0;
        bool flag = 0;
        for(int i = 0; i < B.size(); i += 2, p ++){
            if(i + 1 >= B.size()){
                B[p] = B[i];
                B.resize(p + 1);
                flag = 1;
                break;
            }
            else{
                B[p] = merge(B[i], B[i + 1]);
            }
        }
        if(!flag){
            B.resize(p);
        }
    }
}
