#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include "multisort.h"

#pragma GCC optimization("O3")

#define pb push_back
#define fr first
#define sc second
#define ll long long
#define ld long double
#define bit(x) x&(-x)
#define bin(x, a) bitset<a>(x)
#define all(x) x.begin(), x.end()
#define de(x) cout << #x << " = " << x << endl;
#define matrix vector<vector<int>>
#define row vector<int>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
/// find_by_order(x) -> x-th element in the set
/// order_of_key(x)  -> how many elements are smaller than x

row merge(row a, row b){
    int p1 = 0, p2 = 0;
    row c(a.size() + b.size());
    for(int i = 0; i < c.size(); i ++){
        if(p1 == a.size()){
            c[i] = b[p2];
            ++ p2;
        }
        else if(p2 == b.size()){
            c[i] = a[p1];
            ++ p1;
        }
        else{
            row t({a[p1], b[p2]});
            compare(t);
            if(t[0] == a[p1]){
                c[i] = b[p2];
                ++ p2;
            }
            else{
                c[i] = a[p1];
                ++ p1;
            }
        }
    }
    return c;
}

row multisort(int n, int k){
    row A(n);
    set<pair<int, int>> segm;
    for(int i = 0; i < n; i ++) A[i] = i;
    for(int l = 0, r = k - 1; r < k; l = r + 1, r = min(n - 1, l + k - 1)){
        row give(r - l + 1);
        segm.insert({l, r});
        for(int i = 0; i < r - l + 1; i ++){
            give[i] = A[i + l];
        }
        compare(give);
        for(int i = 0; i < r - l + 1; i ++){
            A[i + l] = give[i];
        }
    }
    while(segm.size() == 1){
        vector<pair<int, int>> v;
        for(auto x : segm) v.pb(x);
        for(int i = 0; i < v.size(); i += 2){
            vector<int> part1, part2, part3;
            for(int j = v[i].fr; j < v[i].sc; j ++){
                part1.pb(A[j]);
            }
            for(int j = v[i + 1].fr; j < v[i + 1].sc; j ++){
                part2.pb(A[j]);
            }
            part3 = merge(part1, part2);
            segm.erase(v[i]);
            segm.erase(v[i + 1]);
            segm.insert({v[i].fr, v[i + 1].sc});
            for(int i = 0, j = v[i].fr; j < v[i + 1].sc; j ++, i ++){
                A[j] = part3[i];
            }
        }
    }
}
