#include <bits/stdc++.h>
#include "rain.h"

using namespace std;

const int maxn = 3e5 + 3;

vector <pair <int, int> > adj[maxn];
int nn;
void init(int n, int m, int a[], int b[], long long c[])
{
    nn = n;
    for (int i = 0; i < m; i++)
    {
        adj[a[i]].push_back({c[i], b[i]});
        adj[b[i]].push_back({c[i], a[i]});
    }

    for (int i = 1; i <= n; i++)
        sort (adj[i].begin(), adj[i].end());
}

double ans[maxn];
void pass(int ver, int par)
{
    for (auto i: adj[ver])
    if (i.second != par)
    {
        if (ans[ver] <= i.first)
            break;

        auto prev = ans[i.second] + ans[ver] - i.first;
        ans[i.second] += ans[ver] - i.first;
        ans[ver] = i.first;
        pass(i.second, ver);

        if (ans[i.second] == prev)
        {
            double t = (ans[ver] + ans[i.second]) / 2.0;
            ans[i.first] = ans[i.second] = t;
        }
    }
}

double query(long long w, int k)
{
    for (int i = 1; i <= nn; i++)
        ans[i] = 0;

    for (int i = 1; i <= w; i++)
    {
        ans[1]++;
        pass(1, -1);
    }

    return ans[k];
}

/*
int main()
{
    int n, m, a[1003], b[1003];
    long long c[1003];
    cin >> n >> m;
    for (int i = 0; i < m; i++)
        cin >> a[i] >> b[i] >> c[i];

    init(n, m, a, b, c);

    int q;
    cin >> q;
    while (q--)
    {
        long long w;
        int k;
        cin >> w >> k;

        cout << query(w, k) << endl;
    }
}
*/
