#include <vector>

std::vector<int> multisort(int n, int k);
void compare(std::vector<int>& elems);

#include <bits/stdc++.h>
using namespace std;

vector<int> beg;
vector<int> ans, cpy;
int N, K;
int sqr;


const int MAX_NN = 2e4 + 10;
int bckPlace[MAX_NN];
vector<int> now, ret;

vector<int> merge(vector<vector<int> > &help) {
    now.resize(0);
    ret.resize(0);
    for(int i = 0; i < sqr; i ++) {
        for(auto it : help[i]) {
            bckPlace[it] = i;
        }
        reverse(help[i].begin(), help[i].end());
    }
    for(int i = 0; i < sqr; i ++) {
        for(int j = 0; j < sqr && !help[i].empty(); j ++) {
            now.push_back(help[i].back());
            help[i].pop_back();
        }
    }
    while(!now.empty()) {
        compare(now);
        reverse(now.begin(), now.end());
        for(int i = 0; !now.empty() && i < sqr; i ++) {
            ret.push_back(now.back());
            int nowb = bckPlace[now.back()];
            if(!help[nowb].empty()) {
                now.push_back(help[nowb].back());
                help[nowb].pop_back();
            }
            now.pop_back();
        }
        reverse(now.begin(), now.end());
    }
    //cout << "Merged " << ret.size() << endl;
    return ret;
}

void mergeSort(vector<int> &curr) {
    if(curr.size() <= K) {
        compare(curr);
        return;
    }
    vector<vector<int> > help;
    help.resize(sqr);
    //cout << "Sort " << curr.size() << endl;
    for(int i = 0; i < curr.size(); i ++) {
        help[i % sqr].push_back(curr[i]);
        //cout << i << "-> "  << (i % sqr) << endl;
    }
    for(int i = 0; i < sqr; i ++) {
        mergeSort(help[i]);
    }
    //cout << "Sorting with sze "  << curr.size() << " " << endl;
    curr = merge(help);
}

bool cmp(int a, int b) {
    vector<int> vec = {a, b};
    compare(vec);
    return vec[0] == a;
}

vector<int> multisort(int _n, int _k) {
    N = _n;
    K = _k;
    for(int i = 0; i < N; i ++) {
        beg.push_back(i);
    }
    if(K < 4) {
        sort(beg.begin(), beg.end(), cmp);
    } else {
        sqr = 0;
        while(sqr * sqr <= K) {sqr ++;}
        sqr --;
        //cout << "Sqr " << sqr << endl;
        mergeSort(beg);
    }
    return beg;
}

