#include <bits/stdc++.h>

using namespace std;

const int MAXN = 5e3 + 5;

struct kvad
{
	int x, x2;

	kvad(int _x, int _x2)
	{
		x = _x; x2 = _x2;
	}
	kvad(){};

	bool is_intersect(kvad other)
	{
		if((x < other.x && x2 > other.x) || (x < other.x2 && x2 > other.x2)) return true;
		return false;
	}
};

int n, m;
int st1, st2;
int a[MAXN], b[MAXN];
kvad kv1[MAXN], kv2[MAXN];

void read_input()
{
	cin >> n;
	cin >> st1;
	for(int i = 0; i < n; i++)
	{
		cin >> a[i];
		int r = a[i] / 2;
		kv1[i] = kvad(st1 - r, st1 + r);
	}
	cin >> m;
	cin >> st2;
	for(int i = 0; i < m; i++)
	{
		cin >> b[i];
		int r = b[i] / 2;
		kv2[i] = kvad(st2 - r, st2 + r);
	}
}

void solve()
{
	int answer = n + m;
	for(int i = 0; i < n; i++)
	{
		for(int j = 0; j < m; j++)
		{
			if(a[i] < b[j])
			{
				if(kv1[i].is_intersect(kv2[j])) 
				{	
					answer++;
				}
			}
			else
			{
				//cout << "DSA";
				if(kv2[j].is_intersect(kv1[i]))
				{
					answer++;
				}
			}
		}
	}
	cout << answer << "\n";
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	read_input();
	solve();

	return 0;
}
