
#include "multisort.h"
#include <bits/stdc++.h>
using namespace std;

void compare(std::vector<int>& elems);
std::vector<int> multisort(int n, int k);
int idx[21000];
vector<int> msort(vector<int> &v, int k)
{

    if(v.size() <= 1)return v;
    if(v.size() <= k)
    {
        compare(v);
        return v;
    }
    int br = 0, l = 0, r = 0, lc = 0, rc = 0,  mid;
    vector<int> ans, tmp;
    mid = v.size() / 2;
    vector<int> h, g;
    for(int i = 0; i < mid; i++)h.push_back(v[i]);
    for(int i = mid; i < v.size(); i++)g.push_back(v[i]);
    h = msort(h, k);
    g = msort(g, k);
    for(int i = 0; i < v.size(); i++)idx[v[i]] = -1;
    while(l < h.size() && r < g.size())
    {
        if(idx[h[l]] == -1 || idx[g[r]] == -1)
        {
            if(idx[h[l]] == -1)rc = r;
            else lc = l;
            while(tmp.size() > 0)tmp.pop_back();
            for(int i = 0; i < k / 2 + (k % 2); i++)
            {
                if(lc + i >= h.size())
                {
                    lc += i;
                    break;
                }
                tmp.push_back(h[lc + i]);
            }
            lc += k / 2 + (k % 2);
            for(int i = 0; i < k / 2; i++)
            {
                if(rc + i >= g.size())
                {
                    rc += i;
                    break;
                }
                tmp.push_back(g[rc + i]);
            }
            rc += k / 2;
            while(tmp.size() < k && lc < h.size())tmp.push_back(h[lc++]);
            while(tmp.size() < k && rc < g.size())tmp.push_back(g[rc++]);
            compare(tmp);
            for(int i = 0; i < tmp.size(); i++)idx[tmp[i]] = br++;
        }
        if(idx[h[l]] < idx[g[r]])ans.push_back(h[l++]);
        else ans.push_back(g[r++]);
    }
    while(l < h.size())ans.push_back(h[l++]);
    while(r < g.size())ans.push_back(g[r++]);
    v = ans;
    return v;
}

std::vector<int> multisort(int n, int k)
{
    vector<int> v;
    for(int i = 0; i < n; i++)v.push_back(i);
    return msort(v, k);
}
