
#include "multisort.h"
#include <bits/stdc++.h>
using namespace std;

void compare(std::vector<int>& elems);
std::vector<int> multisort(int n, int k);

int idx[21000];
vector<int> msort(vector<int> &v, int k)
{
    if(k < 200)
    {
        if(v.size() <= 1)return v;
    }
    else 
    {
        if(v.size() <= k/16)return v;
    }
    if(v.size() <= k)
    {
        compare(v);
        return v;
    }
    int br = 0, l = 0, r = 0, lc = 0, rc = 0,  mid;
    vector<int> ans, tmp;
    mid = v.size() / 2;
    if(v.size()< 2 *k)mid = k;
    vector<int> h, g;
    for(int i = 0; i < mid; i++)h.push_back(v[i]);
    for(int i = mid; i < v.size(); i++)g.push_back(v[i]);
    h = msort(h, k);
    g = msort(g, k);
    for(int i = 0; i < v.size(); i++)idx[v[i]] = -1;
    while(l < h.size() && r < g.size())
    {
        if(idx[h[l]] == -1 || idx[g[r]] == -1)
        {
            if(idx[h[l]] == -1)rc = r;
            else lc = l;
            while(tmp.size() > 0)tmp.pop_back();
            for(int i = 0; i < k / 2; i++)
            {
                if(lc + i >= h.size())
                {
                    lc += i;
                    break;
                }
                tmp.push_back(h[lc + i]);
            }
            lc += k / 2;
            for(int i = 0; i < k / 2 + (k % 2); i++)
            {
                if(rc + i >= g.size())
                {
                    rc += i;
                    break;
                }
                tmp.push_back(g[rc + i]);
            }
            rc += k / 2 + (k % 2);
            while(tmp.size() < k && lc < h.size())tmp.push_back(h[lc++]);
            while(tmp.size() < k && rc < g.size())tmp.push_back(g[rc++]);
            compare(tmp);
            for(int i = 0; i < tmp.size(); i++)idx[tmp[i]] = br++;
        }
        if(idx[h[l]] < idx[g[r]])ans.push_back(h[l++]);
        else ans.push_back(g[r++]);
    }
    while(l < h.size())ans.push_back(h[l++]);
    while(r < g.size())ans.push_back(g[r++]);
    v = ans;
    return v;
}
std::mt19937 gen;

std::vector<int> multisort(int n, int k)
{
    vector<int> v;
    for(int i = 0; i < n; i++)v.push_back(i);
    for(int i = 0; i < 8; i++)shuffle(v.begin(), v.end(), gen);
    return msort(v, k);
}

/*
///////////////////////////////////

std::mt19937 generator;

static const int MAX_N = 20000;
static int n, k;

static int val[MAX_N];

static bool valid;
static long long cnt;

static void initVals()
{
    for (int i = 0; i < n; ++i)
    {
        val[i] = i;
    }
    std::shuffle(val, val + n, generator);
}

static bool cmpByValue(int a, int b)
{
    return val[a] < val[b];
}

void compare(std::vector<int>& elems)
{
    if ((int) elems.size() > k)
    {
        valid = false;
        return;
    }
    ++cnt;
    std::sort(elems.begin(), elems.end(), cmpByValue);
}

static void oneTest(bool printCorrect=true)
{
    valid = true;
    cnt = 0;
    initVals();
    std::vector<int> res = multisort(n, k);
    if (!valid)
    {
        std::cout << "Used invalid comparisons." << std::endl;
        return;
    }
    if ((int) res.size() != n)
    {
        std::cout << "Returned too many or too few numbers." << std::endl;
        return;
    }
    for (int i = 0; i < n; ++i)
    {
        if (res[i] < 0 || res[i] >= n)
        {
            std::cout << "Out of range." << std::endl;
            return;
        }
    }
    for (int i = 1; i < n; ++i)
    {
        if (val[res[i]] < val[res[i - 1]])
        {
            std::cout << "Not sorted." << std::endl;
            return;
        }
    }
    if (printCorrect) std::cout << "Correctly sorted with " << cnt << " comparisons." << std::endl;
}

long long findMax(int iters=10)
{
    long long worst = 0;
    for (int i = 0; i < iters; ++i)
    {
        oneTest(false);
        worst = std::max(worst, cnt);
    }
    return worst;
}

long long findAvg(int iters=10)
{
    long long total = 0;
    for (int i = 0; i < iters; ++i)
    {
        oneTest(false);
        total += cnt;
    }
    return (total + iters / 2) / iters;
}

int main()
{
    n = 20000;
    int seed;
    std::cin >> k >> seed;
    generator.seed(seed);
    oneTest();
}
*/
