#include "multisort.h"
#include "Lgrader.cpp"

#include <bits/stdc++.h>
using namespace std;

vector<int> multisort(int n, int k)
{
    vector<int> v;
    for (int i = 0; i < n; ++ i)
    {
        v.push_back(i);
    }

    while (true)
    {
        bool fl = false;

        for (int p = 0; p < n; p += k / 2)
        {
            vector<int> elems;
            for (int i = p; i < min(n, p + k); ++ i)
            {
                elems.push_back(v[i]);
            }

            compare(elems);

            for (int i = p; i < min(n, p + k); ++ i)
            {
                if (v[i] != elems[i - p])
                {
                    fl = true;
                    v[i] = elems[i - p];
                }
            }
        }

        for (int p = n - p; ; p -= k / 2)
        {
            if (p < 0) p = 0;

            vector<int> elems;
            for (int i = p; i < min(n, p + k); ++ i)
            {
                elems.push_back(v[i]);
            }

            compare(elems);

            for (int i = p; i < min(n, p + k); ++ i)
            {
                if (v[i] != elems[i - p])
                {
                    fl = true;
                    v[i] = elems[i - p];
                }
            }

            if (p == 0) break;
        }

        if (!fl) return v;
    }
}
