#include "multisort.h"
//#include "Lgrader.cpp"

#include <bits/stdc++.h>
using namespace std;

vector<int> v;
int N, K;

void mergesort(int l, int r)
{
    if (l == r) return;

    int mid = (l + r) / 2;
    mergesort(l, mid + 0);
    mergesort(mid + 1, r);

    vector<int> m;

    int le = l * K, ri = (mid + 1) * K;
    int endL = ri, endR = min((r + 1) * K, N);
    int from = le, to = endR;

   /* cout << l << ' ' << r << ' ' << mid << endl;
    cout << le << ' ' << endL << " and " << ri << ' ' << endR << endl;
    cout << "combine: " << endl;
    for (int i = le; i < endL; ++ i) cout << v[i] << ' ';
    cout << endl;
    for (int i = ri; i < endR; ++ i) cout << v[i] << ' ';
    cout << endl;*/


    set<int> fp, sp;
    while (fp.size() < K / 2 and le < endL) fp.insert(v[le++]);
    while (sp.size() < K / 2 and ri < endR) sp.insert(v[ri++]);

    while (!fp.empty() and !sp.empty())
    {
        vector<int> elems;
        for (int x : fp) elems.push_back(x);
        for (int x : sp) elems.push_back(x);

       /* cout << "compare: ";
        for (int i = 0; i < elems.size(); ++ i) cout << elems[i] << ' ';
        cout << endl;*/

        compare(elems);
      /* for (int i = 0; i < elems.size(); ++ i) cout << elems[i] << ' ';
        cout << endl;*/

        for (int i = 0; i < elems.size() / 2; ++ i)
        {
            m.push_back(elems[i]);
            if (fp.count(elems[i]) == 1) fp.erase(elems[i]);
            else sp.erase(elems[i]);
        }

        while (fp.size() < K / 2 and le < endL) fp.insert(v[le++]);
        while (sp.size() < K / 2 and ri < endR) sp.insert(v[ri++]);
    }

    le -= fp.size();
    ri -= sp.size();
    while (le < endL) m.push_back(v[le++]);
    while (ri < endR) m.push_back(v[ri++]);

    for (int i = from; i < to; ++ i)
    {
        v[i] = m[i - from];
        //cout << m[i - l * K] << ' ' ;
    }
    //cout << endl;
}

vector<int> multisort(int n, int k)
{
    N = n; K = k;

    for (int i = 0; i < N; ++ i)
    {
        v.push_back(i);
    }

    for (int p = 0; p < N; p += K)
    {
        vector<int> elems;
        for (int i = p; i < min(N, p + K); ++ i)
        {
            elems.push_back(v[i]);
        }
        compare(elems);
        for (int i = p; i < min(N, p + K); ++ i)
        {
            v[i] = elems[i - p];
        }
    }

   /* cout << "first: ";
    for (int i = 0; i < N; ++ i)
    {
        cout << v[i] << ' ';
    }
    cout << endl;*/

    int l = 0, r = N / K - 1;
    if (N % K != 0) r++;
    mergesort(l, r);

   /* cout << "sort : ";
    for (int i = 0; i < N; ++ i)
    {
        cout << v[i] << ' ';
    }
    cout << endl;*/

    return v;


}
